classdef vector
    properties(Access = private)
      %basis
      B
      %coordinate vector
      c
    end
    
    methods
        % constructor 
        function v = vector(bas,coo)
            if ~isa(bas,'basis')
                error('First argument must be a basis.');
            end
            if ~isnumeric(coo)
                error('Coordinates (2nd argument) must be of numeric type.');
            end
            if numel(coo)~=bas.dim
                error('Coordinate vector has wrong dimension.');
            end
            v.B = bas;
            v.c = reshape(coo,bas.dim,1);
        end
        
        % overloading display 
        function display(this)
            fprintf('Coordinates w.r.t. ');
            this.B
            c = this.c
        end

        % oveloading +
        function w = plus(u,v)
            if ~isa(u,'vector') || ~isa(v,'vector') || u.B~=v.B
                error('Addition not defined.');
            end
            w = vector(u.B,u.c + v.c);
        end
    end
end
